/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PeriodoVacacionalDAO;
import com.rjconsultores.ventaboletos.entidad.PeriodoVacacional;
import com.rjconsultores.ventaboletos.service.PeriodoVacacionalService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("periodoVacacionalService")
public class PeriodoVacacionalServiceImpl implements PeriodoVacacionalService {

    @Autowired
    private PeriodoVacacionalDAO periodoVacacionalDAO;

    public List<PeriodoVacacional> obtenerTodos() {
        return periodoVacacionalDAO.obtenerTodos();
    }

    public PeriodoVacacional obtenerID(Integer id) {
        return periodoVacacionalDAO.obtenerID(id);
    }

    @Transactional
    public PeriodoVacacional suscribir(PeriodoVacacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return periodoVacacionalDAO.suscribir(entidad);
    }

    @Transactional
    public PeriodoVacacional actualizacion(PeriodoVacacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return periodoVacacionalDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PeriodoVacacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        periodoVacacionalDAO.actualizacion(entidad);
    }

    public List<PeriodoVacacional> buscar(Date dataInicio, Date dataFim) {
        return periodoVacacionalDAO.buscar(dataInicio, dataFim);
    }

    public List<PeriodoVacacional> buscarFechaTraslapa(PeriodoVacacional periodoVacacional) {
        return periodoVacacionalDAO.buscarFechaTraslapa(periodoVacacional);
    }
}
